include ht48E30.inc

include lcmglob.inc
include command.inc

public _send_char  				
public _send_cmd
public _send_string_RAM
public _send_string_ROM
public _init_LCD
public _cls_LCD

public send_char0
public send_cmd0
public send_string_RAM0
public send_string_ROM0

dsec 	.section    'data'
send_string_ROM0 label byte
send_string_RAM0 label byte
send_cmd0 label byte
send_char0	db ?

scode	.section	'code'					

_send_cmd:
		call busy_chk
		mov a,send_cmd0
snd_cmd:
		mov	lcm_data,a				; pone comando en bus
		clr	lcm_ctrl.rw				; RW=W
		clr	lcm_ctrl.rs				; RS=0 (comando)
		set	lcm_ctrl.e      		; pulso en E
		clr	lcm_ctrl.e      
    	ret                                     	

busy_chk:                                       	
		set	lcm_data_ctrl   		; pone bus como entradas
		clr lcm_ctrl.rs  	 		; RS=0 (comando)
		set lcm_ctrl.rw  			; RW=R
		set lcm_ctrl.e    			; sube E
		mov a,lcm_data 				; lee bus
		clr lcm_ctrl.e              ; baja E
		sz acc.7        			; bit 7 = 0 ?	
		jmp busy_chk     			; no, loop
		clr lcm_ctrl.rw             ; s, RW=W
		clr lcm_data_ctrl   		; pone bus como salidas
		ret

_send_char:
		call busy_chk
		mov a,send_char0
write_char:
		mov lcm_data,a				; pone dato en bus
		clr lcm_ctrl.rw				; RW=W
		set lcm_ctrl.rs				; RS=1 (dato)
		set lcm_ctrl.e				; pulso en E
		clr lcm_ctrl.e                             
		ret


_init_LCD:
		mov a,38h     		 			;  8 bit, 2 lineas, caracteres 5x7
		call snd_cmd 				

		call busy_chk				
		mov a,06h						; inc address, desplaza cursor
		call snd_cmd 				
		call busy_chk				
		mov a,0Ch						; sin cursor, ni blink 
		call snd_cmd 				
_cls_LCD:
		call busy_chk				
		mov	a,lcm_cls					; clear screen
		call snd_cmd  				
		call busy_chk				
		mov	a,cursor_home
		jmp snd_cmd  				


_send_string_RAM:
		mov A,send_string_RAM0
		mov MP0,A
ssloop:	call busy_chk  
		mov A,IAR0
		sz ACC
		jmp ssl1
		ret    				
ssl1:	call write_char 				
		inc MP0
		jmp ssloop

ssrom 	.section INPAGE 'CODE'	
_send_string_ROM:
		mov A,send_string_ROM0
		call setstring
		mov TBLP,A
ss2lop:	call busy_chk  
		tabrdc ACC		 			
		sz ACC
		jmp ss2l1
		ret    				
ss2l1:	call write_char 				
		inc TBLP     		
		jmp ss2lop

; strings

txt1:	dw	67,105,107,97,32,69,108,101,99,116,114,111,110,105,99,97,0
txt2:	dw	72,111,108,116,101,107,32,76,67,68,32,100,101,109,111,0

ss	 	.section INPAGE 'CODE'	
setstring:
		addm a,PCL
		ret a,OFFSET txt1
		ret a,OFFSET txt2
		;

